Index: exampleparties/anac2019/agentgg/pom.xml
===================================================================
--- exampleparties/anac2019/agentgg/pom.xml	(revision 20)
+++ exampleparties/anac2019/agentgg/pom.xml	(revision 21)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties.anac2019</groupId>
 	<artifactId>agentgg</artifactId>
-	<version>1.4.4</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.0</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
-		<geniusweb.version>1.4.4</geniusweb.version>
+		<geniusweb.version>1.5.0</geniusweb.version>
 	</properties>
 
@@ -60,5 +60,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>immutablelist</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: exampleparties/anac2019/agentgg/src/main/java/geniusweb/exampleparties/agentgg/AgentGG.java
===================================================================
--- exampleparties/anac2019/agentgg/src/main/java/geniusweb/exampleparties/agentgg/AgentGG.java	(revision 20)
+++ exampleparties/anac2019/agentgg/src/main/java/geniusweb/exampleparties/agentgg/AgentGG.java	(revision 21)
@@ -19,13 +19,13 @@
 import geniusweb.actions.PartyId;
 import geniusweb.bidspace.AllBidsList;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.Value;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.PartialOrdering;
 import geniusweb.profileconnection.ProfileConnectionFactory;
Index: exampleparties/anac2019/agentgg/src/test/java/geniusweb/exampleparties/agentgg/AgentGGTest.java
===================================================================
--- exampleparties/anac2019/agentgg/src/test/java/geniusweb/exampleparties/agentgg/AgentGGTest.java	(revision 20)
+++ exampleparties/anac2019/agentgg/src/test/java/geniusweb/exampleparties/agentgg/AgentGGTest.java	(revision 21)
@@ -34,11 +34,11 @@
 import geniusweb.actions.PartyId;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.DefaultPartialOrdering;
 import geniusweb.profile.PartialOrdering;
Index: exampleparties/anac2019/winkyagent/pom.xml
===================================================================
--- exampleparties/anac2019/winkyagent/pom.xml	(revision 20)
+++ exampleparties/anac2019/winkyagent/pom.xml	(revision 21)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties.anac2019</groupId>
 	<artifactId>winkyagent</artifactId>
-	<version>1.4.4</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.0</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
-		<geniusweb.version>1.4.4</geniusweb.version>
+		<geniusweb.version>1.5.0</geniusweb.version>
 	</properties>
 
@@ -60,5 +60,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>immutablelist</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: exampleparties/anac2019/winkyagent/src/main/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgent.java
===================================================================
--- exampleparties/anac2019/winkyagent/src/main/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgent.java	(revision 20)
+++ exampleparties/anac2019/winkyagent/src/main/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgent.java	(revision 21)
@@ -19,4 +19,9 @@
 import geniusweb.actions.PartyId;
 import geniusweb.bidspace.AllBidsList;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.DiscreteValue;
@@ -26,9 +31,4 @@
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.PartialOrdering;
 import geniusweb.profileconnection.ProfileConnectionFactory;
Index: exampleparties/anac2019/winkyagent/src/test/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgentTest.java
===================================================================
--- exampleparties/anac2019/winkyagent/src/test/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgentTest.java	(revision 20)
+++ exampleparties/anac2019/winkyagent/src/test/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgentTest.java	(revision 21)
@@ -34,11 +34,11 @@
 import geniusweb.actions.PartyId;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.DefaultPartialOrdering;
 import geniusweb.profile.PartialOrdering;
Index: exampleparties/boulware/pom.xml
===================================================================
--- exampleparties/boulware/pom.xml	(revision 20)
+++ exampleparties/boulware/pom.xml	(revision 21)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>boulware</artifactId>
-	<version>1.4.4</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.0</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
-		<geniusweb.version>1.4.4</geniusweb.version>
+		<geniusweb.version>1.5.0</geniusweb.version>
 	</properties>
 
Index: exampleparties/comparebids/pom.xml
===================================================================
--- exampleparties/comparebids/pom.xml	(revision 20)
+++ exampleparties/comparebids/pom.xml	(revision 21)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>comparebids</artifactId>
-	<version>1.4.4</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.0</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
-		<geniusweb.version>1.4.4</geniusweb.version>
+		<geniusweb.version>1.5.0</geniusweb.version>
 	</properties>
 
@@ -55,5 +55,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>immutablelist</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: exampleparties/comparebids/src/main/java/geniusweb/exampleparties/comparebids/CompareBids.java
===================================================================
--- exampleparties/comparebids/src/main/java/geniusweb/exampleparties/comparebids/CompareBids.java	(revision 20)
+++ exampleparties/comparebids/src/main/java/geniusweb/exampleparties/comparebids/CompareBids.java	(revision 21)
@@ -12,11 +12,11 @@
 import geniusweb.actions.ElicitComparison;
 import geniusweb.actions.PartyId;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
 import geniusweb.profile.PartialOrdering;
 import geniusweb.profile.Profile;
Index: exampleparties/comparebids/src/test/java/geniusweb/exampleparties/comparebids/CompareBidsTest.java
===================================================================
--- exampleparties/comparebids/src/test/java/geniusweb/exampleparties/comparebids/CompareBidsTest.java	(revision 20)
+++ exampleparties/comparebids/src/test/java/geniusweb/exampleparties/comparebids/CompareBidsTest.java	(revision 21)
@@ -29,9 +29,9 @@
 import geniusweb.bidspace.AllBidsList;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
Index: exampleparties/conceder/pom.xml
===================================================================
--- exampleparties/conceder/pom.xml	(revision 20)
+++ exampleparties/conceder/pom.xml	(revision 21)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>conceder</artifactId>
-	<version>1.4.4</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.0</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
-		<geniusweb.version>1.4.4</geniusweb.version>
+		<geniusweb.version>1.5.0</geniusweb.version>
 	</properties>
 
Index: exampleparties/hardliner/pom.xml
===================================================================
--- exampleparties/hardliner/pom.xml	(revision 20)
+++ exampleparties/hardliner/pom.xml	(revision 21)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>hardliner</artifactId>
-	<version>1.4.4</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.0</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
-		<geniusweb.version>1.4.4</geniusweb.version>
+		<geniusweb.version>1.5.0</geniusweb.version>
 	</properties>
 
Index: exampleparties/humangui/pom.xml
===================================================================
--- exampleparties/humangui/pom.xml	(revision 20)
+++ exampleparties/humangui/pom.xml	(revision 21)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>humangui</artifactId>
-	<version>1.4.4</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.0</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
-		<geniusweb.version>1.4.4</geniusweb.version>
+		<geniusweb.version>1.5.0</geniusweb.version>
 	</properties>
 
@@ -46,9 +46,4 @@
 			<artifactId>profileconnection</artifactId>
 			<version>${geniusweb.version}</version>
-		</dependency>
-		<dependency>
-			<groupId>tudelft.utilities</groupId>
-			<artifactId>immutablelist</artifactId>
-			<version>1.1.0</version>
 		</dependency>
 		<dependency>
Index: exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/BiddingInfo.java
===================================================================
--- exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/BiddingInfo.java	(revision 20)
+++ exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/BiddingInfo.java	(revision 21)
@@ -13,7 +13,7 @@
 import geniusweb.actions.PartyId;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
 import geniusweb.issuevalue.Bid;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
 import geniusweb.profile.Profile;
 import geniusweb.profileconnection.ProfileInterface;
Index: exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/HumanGui.java
===================================================================
--- exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/HumanGui.java	(revision 20)
+++ exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/HumanGui.java	(revision 21)
@@ -11,12 +11,12 @@
 import geniusweb.actions.Action;
 import geniusweb.actions.Offer;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
 import geniusweb.party.Party;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profileconnection.ProfileConnectionFactory;
 import geniusweb.profileconnection.ProfileInterface;
Index: exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/BiddingInfoTest.java
===================================================================
--- exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/BiddingInfoTest.java	(revision 20)
+++ exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/BiddingInfoTest.java	(revision 21)
@@ -29,6 +29,6 @@
 import geniusweb.actions.Accept;
 import geniusweb.actions.PartyId;
+import geniusweb.inform.Settings;
 import geniusweb.issuevalue.Bid;
-import geniusweb.party.inform.Settings;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
Index: exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/HumanGuiTest.java
===================================================================
--- exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/HumanGuiTest.java	(revision 20)
+++ exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/HumanGuiTest.java	(revision 21)
@@ -27,10 +27,10 @@
 import geniusweb.actions.PartyId;
 import geniusweb.bidspace.AllBidsList;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
Index: exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/MyGUITest.java
===================================================================
--- exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/MyGUITest.java	(revision 20)
+++ exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/MyGUITest.java	(revision 21)
@@ -19,6 +19,6 @@
 import geniusweb.actions.PartyId;
 import geniusweb.connection.ConnectionEnd;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
 import geniusweb.profileconnection.ProfileConnectionFactory;
 import geniusweb.profileconnection.ProfileInterface;
Index: exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/TestConnection.java
===================================================================
--- exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/TestConnection.java	(revision 20)
+++ exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/TestConnection.java	(revision 21)
@@ -8,5 +8,5 @@
 import geniusweb.actions.Action;
 import geniusweb.connection.ConnectionEnd;
-import geniusweb.party.inform.Inform;
+import geniusweb.inform.Inform;
 import geniusweb.references.Reference;
 import tudelft.utilities.listener.DefaultListenable;
Index: exampleparties/linear/pom.xml
===================================================================
--- exampleparties/linear/pom.xml	(revision 20)
+++ exampleparties/linear/pom.xml	(revision 21)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>linear</artifactId>
-	<version>1.4.4</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.0</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
-		<geniusweb.version>1.4.4</geniusweb.version>
+		<geniusweb.version>1.5.0</geniusweb.version>
 	</properties>
 
Index: exampleparties/randomparty/pom.xml
===================================================================
--- exampleparties/randomparty/pom.xml	(revision 20)
+++ exampleparties/randomparty/pom.xml	(revision 21)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randomparty</artifactId>
-	<version>1.4.4</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.0</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
-		<geniusweb.version>1.4.4</geniusweb.version>
+		<geniusweb.version>1.5.0</geniusweb.version>
 	</properties>
 
@@ -55,5 +55,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>immutablelist</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java
===================================================================
--- exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 20)
+++ exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 21)
@@ -5,6 +5,8 @@
 import java.util.Arrays;
 import java.util.HashSet;
+import java.util.List;
 import java.util.Random;
 import java.util.logging.Level;
+import java.util.stream.Collectors;
 
 import geniusweb.actions.Accept;
@@ -12,13 +14,17 @@
 import geniusweb.actions.Offer;
 import geniusweb.actions.PartyId;
+import geniusweb.actions.Vote;
+import geniusweb.actions.Votes;
 import geniusweb.bidspace.AllPartialBidsList;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.OptIn;
+import geniusweb.inform.Settings;
+import geniusweb.inform.Voting;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.PartialOrdering;
 import geniusweb.profile.Profile;
@@ -33,4 +39,7 @@
  * A simple party that places random bids and accepts when it receives an offer
  * with sufficient utility.
+ * <h2>voting</h2> If the party receives a parameter "minPower", it will
+ * {@link Vote} using that minPower instead of the default value 2 if it
+ * receives a {@link Voting} request.
  */
 public class RandomParty extends DefaultParty {
@@ -41,4 +50,6 @@
 	protected ProfileInterface profileint;
 	private Progress progress;
+	private Settings settings;
+	private Votes lastvotes;
 
 	public RandomParty() {
@@ -58,4 +69,5 @@
 				this.me = settings.getID();
 				this.progress = settings.getProgress();
+				this.settings = settings;
 			} else if (info instanceof ActionDone) {
 				Action otheract = ((ActionDone) info).getAction();
@@ -64,10 +76,16 @@
 				}
 			} else if (info instanceof YourTurn) {
-				myTurn();
-				if (progress instanceof ProgressRounds) {
-					progress = ((ProgressRounds) progress).advance();
-				}
+				makeOffer();
+				nextRound();
 			} else if (info instanceof Finished) {
 				getReporter().log(Level.INFO, "Final ourcome:" + info);
+			} else if (info instanceof Voting) {
+				lastvotes = vote((Voting) info);
+				getConnection().send(lastvotes);
+				nextRound();
+			} else if (info instanceof OptIn) {
+				// just repeat our last vote.
+				getConnection().send(lastvotes);
+				nextRound();
 			}
 		} catch (Exception e) {
@@ -76,7 +94,15 @@
 	}
 
+	private void nextRound() {
+		if (progress instanceof ProgressRounds) {
+			progress = ((ProgressRounds) progress).advance();
+		}
+
+	}
+
 	@Override
 	public Capabilities getCapabilities() {
-		return new Capabilities(new HashSet<>(Arrays.asList("SAOP")));
+		return new Capabilities(
+				new HashSet<>(Arrays.asList("SAOP", "AMOP", "MOPAC")));
 	}
 
@@ -86,7 +112,12 @@
 	}
 
-	private void myTurn() throws IOException {
+	/**
+	 * send our next offer
+	 */
+	private void makeOffer() throws IOException {
 		Action action;
-		if (isGood(lastReceivedBid)) {
+		String protocol = settings.getProtocol().getURI().getPath();
+		if ((protocol.equals("SAOP") || protocol.equals("SHAOP"))
+				&& isGood(lastReceivedBid)) {
 			action = new Accept(me, lastReceivedBid);
 		} else {
@@ -105,17 +136,42 @@
 	}
 
-	private boolean isGood(Bid bid) throws IOException {
+	/**
+	 * @param bid the bid to check
+	 * @return true iff bid is good for us.
+	 */
+	private boolean isGood(Bid bid) {
 		if (bid == null)
 			return false;
-		Profile profile = profileint.getProfile();
-		if (profile instanceof UtilitySpace) {
+		Profile profile;
+		try {
+			profile = profileint.getProfile();
+		} catch (IOException e) {
+			throw new IllegalStateException(e);
+		}
+		if (profile instanceof UtilitySpace)
 			return ((UtilitySpace) profile).getUtility(bid).doubleValue() > 0.6;
-		}
 		if (profile instanceof PartialOrdering) {
 			return ((PartialOrdering) profile).isPreferredOrEqual(bid,
 					profile.getReservationBid());
 		}
-		throw new IllegalArgumentException(
-				"Can not handle profile type " + profile.getClass());
+		return false;
+	}
+
+	/**
+	 * @param voting the {@link Voting} object containing the options
+	 * 
+	 * @return our next Votes.
+	 */
+	private Votes vote(Voting voting) throws IOException {
+		Object val = settings.getParameters().get("minPowwer");
+		Integer n = (val instanceof Integer) ? (Integer) val : 2;
+		for (Bid bid : voting.getBids()) {
+			System.out.println("Bid " + bid + "="
+					+ ((UtilitySpace) profileint.getProfile()).getUtility(bid));
+		}
+		List<Vote> votes = voting.getBids().stream().distinct()
+				.filter(bid -> isGood(bid)).map(bid -> new Vote(me, bid, n))
+				.collect(Collectors.toList());
+		return new Votes(me, votes);
 	}
 
Index: exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java
===================================================================
--- exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java	(revision 20)
+++ exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java	(revision 21)
@@ -16,4 +16,6 @@
 import java.nio.file.Files;
 import java.nio.file.Paths;
+import java.util.Arrays;
+import java.util.Collections;
 import java.util.LinkedList;
 import java.util.List;
@@ -32,13 +34,15 @@
 import geniusweb.actions.Offer;
 import geniusweb.actions.PartyId;
+import geniusweb.actions.Votes;
 import geniusweb.bidspace.AllBidsList;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.Voting;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
@@ -53,4 +57,5 @@
 public class RandomPartyTest {
 
+	private static final PartyId PARTY1 = new PartyId("party1");
 	private static final String SAOP = "SAOP";
 	private static final PartyId otherparty = new PartyId("other");
@@ -60,5 +65,5 @@
 	private RandomParty party;
 	private final TestConnection connection = new TestConnection();
-	private final ProtocolRef protocol = mock(ProtocolRef.class);
+	private final ProtocolRef protocol = new ProtocolRef(SAOP);
 	private final ProgressRounds progress = mock(ProgressRounds.class);
 	private Settings settings;
@@ -70,5 +75,5 @@
 			IOException, URISyntaxException {
 		party = new RandomParty();
-		settings = new Settings(new PartyId("party1"),
+		settings = new Settings(PARTY1,
 				new ProfileRef(new URI("file:" + PROFILE)), protocol, progress,
 				parameters);
@@ -189,4 +194,19 @@
 	}
 
+	@Test
+	public void testVoting() {
+		party.connect(connection);
+		party.notifyChange(settings);
+
+		Bid bid = findGoodBid();
+		party.notifyChange(new Voting(Arrays.asList(bid),
+				Collections.singletonMap(PARTY1, 1)));
+		assertEquals(1, connection.getActions().size());
+		Action action = connection.getActions().get(0);
+		assertTrue(action instanceof Votes);
+		assertEquals(1, ((Votes) action).getVotes().size());
+		assertEquals(bid, ((Votes) action).getVotes().get(0).getBid());
+	}
+
 }
 
Index: exampleparties/randompartypy/pom.xml
===================================================================
--- exampleparties/randompartypy/pom.xml	(revision 20)
+++ exampleparties/randompartypy/pom.xml	(revision 21)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randompyparty</artifactId>
-	<version>1.4.4</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.0</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
-		<geniusweb.version>1.4.4</geniusweb.version>
+		<geniusweb.version>1.5.0</geniusweb.version>
 	</properties>
 
@@ -48,5 +48,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>immutablelist</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: exampleparties/randompartypy/src/main/resources/RandomParty.py
===================================================================
--- exampleparties/randompartypy/src/main/resources/RandomParty.py	(revision 20)
+++ exampleparties/randompartypy/src/main/resources/RandomParty.py	(revision 21)
@@ -2,8 +2,8 @@
 import traceback
 
-import geniusweb.party.inform.ActionDone as ActionDone
-import geniusweb.party.inform.Inform as Inform
-import geniusweb.party.inform.Settings as Settings
-import geniusweb.party.inform.YourTurn as YourTurn
+import geniusweb.inform.ActionDone as ActionDone
+import geniusweb.inform.Inform as Inform
+import geniusweb.inform.Settings as Settings
+import geniusweb.inform.YourTurn as YourTurn
 
 
Index: exampleparties/randompartypy/src/test/java/geniusweb/exampleparties/randompartypy/RandomPartyTest.java
===================================================================
--- exampleparties/randompartypy/src/test/java/geniusweb/exampleparties/randompartypy/RandomPartyTest.java	(revision 20)
+++ exampleparties/randompartypy/src/test/java/geniusweb/exampleparties/randompartypy/RandomPartyTest.java	(revision 21)
@@ -32,10 +32,10 @@
 import geniusweb.bidspace.AllBidsList;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
Index: exampleparties/simpleboa/pom.xml
===================================================================
--- exampleparties/simpleboa/pom.xml	(revision 20)
+++ exampleparties/simpleboa/pom.xml	(revision 21)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>simpleboaparty</artifactId>
-	<version>1.4.4</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.0</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
-		<geniusweb.version>1.4.4</geniusweb.version>
+		<geniusweb.version>1.5.0</geniusweb.version>
 	</properties>
 
Index: exampleparties/simpleboa/src/main/java/geniusweb/exampleparties/simpleboa/SimpleBoa.java
===================================================================
--- exampleparties/simpleboa/src/main/java/geniusweb/exampleparties/simpleboa/SimpleBoa.java	(revision 20)
+++ exampleparties/simpleboa/src/main/java/geniusweb/exampleparties/simpleboa/SimpleBoa.java	(revision 21)
@@ -8,8 +8,8 @@
 import geniusweb.boa.biddingstrategy.BiddingStrategy;
 import geniusweb.boa.biddingstrategy.TimeDependentBiddingStrategy;
+import geniusweb.inform.Settings;
 import geniusweb.opponentmodel.FrequencyOpponentModel;
 import geniusweb.opponentmodel.OpponentModel;
 import geniusweb.party.Party;
-import geniusweb.party.inform.Settings;
 import tudelft.utilities.logging.Reporter;
 
Index: exampleparties/simpleboa/src/test/java/geniusweb/exampleparties/simpleboa/SimpleBoaTest.java
===================================================================
--- exampleparties/simpleboa/src/test/java/geniusweb/exampleparties/simpleboa/SimpleBoaTest.java	(revision 20)
+++ exampleparties/simpleboa/src/test/java/geniusweb/exampleparties/simpleboa/SimpleBoaTest.java	(revision 21)
@@ -36,11 +36,11 @@
 import geniusweb.bidspace.AllBidsList;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
Index: exampleparties/simpleshaop/pom.xml
===================================================================
--- exampleparties/simpleshaop/pom.xml	(revision 20)
+++ exampleparties/simpleshaop/pom.xml	(revision 21)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>simpleshaop</artifactId>
-	<version>1.4.4</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.0</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
-		<geniusweb.version>1.4.4</geniusweb.version>
+		<geniusweb.version>1.5.0</geniusweb.version>
 	</properties>
 
@@ -55,5 +55,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>immutablelist</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java
===================================================================
--- exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java	(revision 20)
+++ exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java	(revision 21)
@@ -16,12 +16,12 @@
 import geniusweb.actions.PartyId;
 import geniusweb.bidspace.AllBidsList;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.PartialOrdering;
 import geniusweb.profileconnection.ProfileConnectionFactory;
Index: exampleparties/simpleshaop/src/test/java/geniusweb/exampleparties/simpleshaop/ShaopPartyTest.java
===================================================================
--- exampleparties/simpleshaop/src/test/java/geniusweb/exampleparties/simpleshaop/ShaopPartyTest.java	(revision 20)
+++ exampleparties/simpleshaop/src/test/java/geniusweb/exampleparties/simpleshaop/ShaopPartyTest.java	(revision 21)
@@ -36,13 +36,13 @@
 import geniusweb.actions.PartyId;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.DiscreteValue;
 import geniusweb.issuevalue.Value;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
 import geniusweb.progress.ProgressRounds;
Index: exampleparties/timedependentparty/pom.xml
===================================================================
--- exampleparties/timedependentparty/pom.xml	(revision 20)
+++ exampleparties/timedependentparty/pom.xml	(revision 21)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>timedependentparty</artifactId>
-	<version>1.4.4</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.0</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
-		<geniusweb.version>1.4.4</geniusweb.version>
+		<geniusweb.version>1.5.0</geniusweb.version>
 	</properties>
 
@@ -55,5 +55,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>immutablelist</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java
===================================================================
--- exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 20)
+++ exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 21)
@@ -13,12 +13,12 @@
 import geniusweb.actions.Offer;
 import geniusweb.actions.PartyId;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
Index: exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyTest.java
===================================================================
--- exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyTest.java	(revision 20)
+++ exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyTest.java	(revision 21)
@@ -34,11 +34,11 @@
 import geniusweb.bidspace.AllBidsList;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
